#ifndef __PICDECODER_H__
#define __PICDECODER_H__
#include "sys.h"
#include "ff.h"
#include "exfuns.h"
//////////////////////////////////////////////////////////////////////////////////	 
//Mini STM32
//JPG/JPEG/BMPͼƬʾ 		   
//ԭ@ALIENTEK
//̳:www.openedv.com
//޸:2010/6/18 
//汾V1.4
//ȨУؾ
//Copyright(C) ԭ 2009-2019
//All rights reserved
//********************************************************************************
//SRAMŻSRAM:12288BYTE			  
//ֲSD,ԽJPEG/JPGBMP
//ͬʱָ֧ʽͼƬʾ

//Դ˳Ż
//JPEGʽ,ѲӦʾкеɫʡȥ.
//ʾͼƬʱ,ٶ
//BMP,Żʾ֧,ԴͼƬкҲȡ
//ѲӦʾкȥ.ͬʱLCDʾģʽΪԶ
//,ٶ.

//BMP,֧16bit 24bit 32bitͼƬʾ
//JPG,ֻ֧JFIFʽ
//JFIFʽ,windowsĻͼȻ󱣴һ,ʽ!  									 
//////////////////////////////////////////////////////////////////////////////////	 	   

//BMPϢͷ
//ض
typedef char  CHAR;
typedef short SHORT;
typedef long  LONG;			   
typedef unsigned long   DWORD;
typedef int             BOOL;
typedef u8              BYTE;
typedef unsigned short  WORD;
  
#define FALSE 0
#define TRUE  1 


typedef __packed struct
{
    DWORD biSize ;		   //˵BITMAPINFOHEADERṹҪ
    LONG  biWidth ;		   //˵ͼĿȣΪλ 
    LONG  biHeight ;	   //˵ͼĸ߶ȣΪλ 
    WORD  biPlanes ;	   //ΪĿ豸˵λֵǱΪ1 
    WORD  biBitCount ;	   //˵/أֵΪ148162432
    DWORD biCompression ;  //˵ͼѹֵֵ֮͡һ
	//BI_RGBûѹ
	//BI_RLE8ÿ8صRLEѹ룬ѹʽ2ֽ(ظؼɫ)  
    //BI_RLE4ÿ4صRLEѹ룬ѹʽ2ֽ
  	//BI_BITFIELDSÿصıָ
    DWORD biSizeImage ;//˵ͼĴСֽΪλBI_RGBʽʱΪ0  
    LONG  biXPelsPerMeter ;//˵ˮƽֱʣ/ױʾ
    LONG  biYPelsPerMeter ;//˵ֱֱʣ/ױʾ
    DWORD biClrUsed ;	   //˵λͼʵʹõĲɫеɫ
    DWORD biClrImportant ; //˵ͼʾҪӰɫĿ0ʾҪ 
}BITMAPINFOHEADER ;
//BMPͷļ
typedef __packed struct
{
    WORD  bfType ;     //ļ־.ֻ'BM',ʶBMPλͼ
    DWORD bfSize ;	   //ļС,ռĸֽ
    WORD  bfReserved1 ;//
    WORD  bfReserved2 ;//
    DWORD bfOffBits ;  //ļʼλͼ(bitmap data)ʼ֮ĵƫ
}BITMAPFILEHEADER ;
//ɫ 
typedef __packed struct 
{
    BYTE rgbBlue ;    //ָɫǿ
    BYTE rgbGreen ;	  //ָɫǿ 
    BYTE rgbRed ;	  //ָɫǿ 
    BYTE rgbReserved ;//Ϊ0 
}RGBQUAD ;
//λͼϢͷ
typedef __packed struct
{ 
	BITMAPFILEHEADER bmfHeader;
	BITMAPINFOHEADER bmiHeader;  
	//RGBQUAD bmiColors[256];  
}BITMAPINFO; 

typedef RGBQUAD * LPRGBQUAD;//ɫ  

//ͼѹ
#define BI_RGB       0L
#define BI_RLE8      1L
#define BI_RLE4      2L
#define BI_BITFIELDS 3L 

#define M_SOF0  0xc0
#define M_DHT   0xc4
#define M_EOI   0xd9
#define M_SOS   0xda
#define M_DQT   0xdb
#define M_DRI   0xdd
#define M_APP0  0xe0  	  


#define W1 2841 /* 2048*sqrt(2)*cos(1*pi/16) */
#define W2 2676 /* 2048*sqrt(2)*cos(2*pi/16) */
#define W3 2408 /* 2048*sqrt(2)*cos(3*pi/16) */
#define W5 1609 /* 2048*sqrt(2)*cos(5*pi/16) */
#define W6 1108 /* 2048*sqrt(2)*cos(6*pi/16) */
#define W7 565  /* 2048*sqrt(2)*cos(7*pi/16) */
												 
	  					    		  
#define MAKEWORD(a, b)      ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
#define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
#define LOWORD(l)           ((WORD)(l))
#define HIWORD(l)           ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))
	   
//궨					   
#define WIDTHBYTES(i)    ((i+31)/32*4)//??????????
#define PI 3.1415926535			
//ֵ
#define FUNC_OK 0
#define FUNC_MEMORY_ERROR 1
#define FUNC_FILE_ERROR 2
#define FUNC_FORMAT_ERROR 3					    			       
//////////////////////////////////////////////////
//BMP뺯
BOOL BmpDecode( u8 *filename);
//////////////////////////////////////////////////

extern long *iclip;//4k BYTES
extern u8 jpg_buffer[1024];//ݻ	

//JPEG 뺯				 
int  InitTag(void);
void InitTable(void);						   //ʼݱ
int  Decode(void);							   //
int  DecodeMCUBlock(void);
int  HufBlock(BYTE dchufindex,BYTE achufindex);//
int  DecodeElement(void);					   //һ
void IQtIZzMCUComponent(short flag);		   //
void IQtIZzBlock(short  *s ,short * d,short flag);
void GetYUV(short flag);		 //ɫתʵ,õɫʿռ
void StoreBuffer(void);

BYTE ReadByte(void);             //ļȡһֽڳ
void Initialize_Fast_IDCT(void); //ʼɢҶ任
void Fast_IDCT(int * block);	 //ٷɢҶ任
void idctrow(int * blk);
void idctcol(int * blk);  
////Իݽƶ,ʹSDsramһ
unsigned int P_Cal(unsigned char*pc);		    
BOOL AI_LoadPicFile( u8 *filename,u16 sx,u16 sy,u16 ex,u16 ey);//ʾͼƬ		 
#endif








